package info.textgrid.middleware;

import java.io.IOException;
import java.text.ParseException;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;

/**
 *
 */
public class OaiPmhClient {

  private String identifier;
  private String metadataPrefix;
  private String set;
  private String from;
  private String until;
  private String resumptionToken;
  private OAIPMHProducer producer;

  /**
   * @param endpoint
   */
  public OaiPmhClient(String endpoint) {
    this.producer = JAXRSClientFactory.create(endpoint + "/oai", OAIPMHProducer.class);
  }

  /**
   * @param verb
   * @return
   * @throws ParseException
 * @throws IOException 
   */
  public String request(String verb) throws ParseException, IOException {
    return this.producer.getRequest(verb, this.identifier, this.metadataPrefix, this.set, this.from,
        this.until, this.resumptionToken);
  }

  /**
   * @return
   */
  @GET
  @Path("/version")
  @Produces(MediaType.TEXT_PLAIN)
  public String getVersion() {
    return OaipmhServiceVersion.BUILDNAME + "-" + OaipmhServiceVersion.VERSION + "+"
        + OaipmhServiceVersion.BUILDDATE;
  }

}